﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Drawing;
using System.Windows.Forms;

namespace Serial
{
    [Serializable]
    public class Data : INotifyPropertyChanged
    {
        int credits;
        float gradePoints;
        string name = "";

        public int Credits {
            get { return credits; }
            set {
                this.credits = value;
                OnChange("Credits");
                OnChange("Gpa");
            }
        }
        public float Gpa
        {
            get
            {
                if (credits > 0)
                {
                    return gradePoints / credits;
                }
                else
                {
                    return 0;
                }
            }
        }
        public float GradePoints
        {
            get { return gradePoints; }
            set { 
                this.gradePoints = value;
                OnChange("GradePoints");
                OnChange("Gpa");
            }
        }
        public string Name {
            get { return name; }
            set { 
                this.name = value;
                OnChange("Name");    
            }
        }
        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        protected void OnChange(string propName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propName));
            }
        }

        #endregion
    }
}
