﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;

namespace Serial
{
    public partial class FormMain : Form
    {
        protected Data data = new Data();
        protected DataISerial dataISerial = new DataISerial();

        public FormMain()
        {
            InitializeComponent();
            this.dataBindingSource.DataSource = dataISerial;
        }

        private void buttonSave_Click(object sender, EventArgs e)
        {
            using (SaveFileDialog dlg = new SaveFileDialog())
            {
                if (dlg.ShowDialog() == DialogResult.OK)
                {
                    Serialize(dlg.FileName);
                }
            }
        }

        private void buttonOpen_Click(object sender, EventArgs e)
        {
            using (OpenFileDialog dlg = new OpenFileDialog())
            {
                if (dlg.ShowDialog() == DialogResult.OK)
                {
                    Deserialize(dlg.FileName);
                }
            }
        }


        public void Serialize(string fileName)
        {
            using (Stream stream =
                new FileStream(fileName, FileMode.Create, FileAccess.Write))
            {
                IFormatter formatter = new BinaryFormatter();
                if (radioButtonSerial.Checked)
                {
                    formatter.Serialize(stream, data);
                }
                else
                {
                    formatter.Serialize(stream, dataISerial);
                }
            }
        }

        public void Deserialize(string fileName)
        {
            using (Stream stream =
                new FileStream(fileName, FileMode.Open, FileAccess.Read))
            {
                IFormatter formatter = new BinaryFormatter();
                if (radioButtonSerial.Checked)
                {
                    data = (Data) formatter.Deserialize(stream);
                    this.dataBindingSource.DataSource = data;
                }
                else
                {
                    dataISerial = (DataISerial) formatter.Deserialize(stream);
                    this.dataBindingSource.DataSource = dataISerial;
                }
            }
        }

        private void radioButtonSerial_CheckedChanged(object sender, EventArgs e)
        {
            this.dataBindingSource.DataSource = data;
        }

        private void radioButtonISerial_CheckedChanged(object sender, EventArgs e)
        {
            this.dataBindingSource.DataSource = dataISerial;
        }

        private void buttonISerial_Click(object sender, EventArgs e)
        {
           
        }
    }
}
